#ifndef DUNE_CRVSRF_SURFACEDISTANCE_HH
#define DUNE_CRVSRF_SURFACEDISTANCE_HH

#include <dune/curvedsurfacegrid/surfacedistance/datastructures.hh>

namespace Dune{ namespace crvsrf{

//--------------------< BackGrid >
struct BackGrid{
  static int segmentation_degree;

  int segments[3];
  Vertex seg_size, minc, maxc;
  double min_seg_size;
  std::vector<std::vector<std::vector<std::list<Element*> > > > grid;
  Mesh &mesh;
  int current_operation_index;

  BackGrid(Mesh &mesh, double expansion_width=-1.0, bool no_scaling=false);
  void debug_output_dimensions();

  double distance_to_surface_2d(const Vertex &destination, Vertex &hit_vertex);
  double distance_to_surface_3d(const Vertex &destination, Vertex &hit_vertex);

  protected:
  void attach_mesh_2d();
  void test_distances_2d(const Vertex &destination, int ix, int iy,
                           double &min_distance, Vertex &hit_vertex);
  void attach_mesh_3d();
  void test_distances_3d(const Vertex &destination, int ix, int iy, int iz,
                                   double &min_distance, Vertex &hit_vertex);
};

}} //end namespace Dune::crvsrf

#endif //DUNE_CRVSRF_SURFACEDISTANCE_HH
